namespace CMSMicroservice.Application.ProductImagesCQ.Commands.CreateNewProductImages;
public class CreateNewProductImagesCommandValidator : AbstractValidator<CreateNewProductImagesCommand>
{
    public CreateNewProductImagesCommandValidator()
    {
        RuleFor(model => model.Title)
            .NotEmpty();
        RuleFor(model => model.ImagePath)
            .NotEmpty();
        RuleFor(model => model.ImageThumbnailPath)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewProductImagesCommand>.CreateWithOptions((CreateNewProductImagesCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
